##Kellen Stephens
##GA Test
##August 31, 2010

import re

class Entity_Extractor(object):
    """This class extracts named entities from files processed by the Stanford NER"""
    
    def __init__(self, text):
        
        self.text = self.set_text(text)
        self.ent_dict = self.sort_ents(self.extract())
        

        
    def set_text(self,text):
      ##Set the text instance variable
      
        try:
            text = open(text, 'r').read()
        except IOError:
            print "unable to open", text
            
        return text  
    
    
    def extract(self):
      ##Extract named entities from source text in text instance variable
      
        ents = re.findall(r'([^/ ]+/(PERSON|LOCATION|ORGANIZATION)(?: [^/ ]+/\2)*)', self.text)
        
        return ents
    
    
    def sort_ents(self, ent_list):
      ##Sort named entities by named entity category
      
        ent_dict = { 'PERSON':set(), 'LOCATION':set(), 'ORGANIZATION':set() }
        
        for word,cat in ent_list:
            
            word = ' '.join([w[:-(len(cat)+1)] for w in word.split()])
            ent_dict[cat].add(word)
        
        return ent_dict
            
            
    def results(self,f):
      ##Print results to output file
      
        try:
            f = open(f, 'w')
        except IOError:
            print 'unable to open', f
            
        for cat in self.ent_dict:
            print >>f, "%-15s" %(cat)
            print >>f
            for word in self.ent_dict[cat]:
                print >>f, word
            print >>f
        f.close() 
            
