
"""
This script calls the Stanford NER and processes its output'
into lists of entities organized by named entity category
(person, location, or organization).  It is not yet fully
portable.

Set the variable C{stanford_ner_dir} correctly below to get the script to run
right.

The assumption is that the location of the stanford_ner source is
on the java CLASSPATH.
"""


import sys, os.path
import crawler_package.Entity_Extractor

home = os.environ['HOME']
root_dir = os.path.join(home, 'Desktop','SWIDSAS', 'software')
stanford_ner_dir = os.path.join(root_dir, \
                                'stanford_named_entity_extractor',\
                                'stanford-ner-2009-01-16')

def main (input_file=None, names_file=None):
    if not (input_file and names_file) and len(sys.argv) <> 3:
        print 'Usage: %s <input_file> <names_file>' % sys.argv[0]
        sys.exit()
    elif not (input_file and names_file):
        input_file = sys.argv[1]
        names_file = sys.argv[2]
        
    ## 3 args: ner_models dir, ner input and output
    command = 'java -mx600m edu.stanford.nlp.ie.crf.CRFClassifier -loadClassifier %s/ner-eng-ie.crf-3-all2008-distsim.ser.gz -textFile %s > %s'

    ner_models_dir = os.path.join(stanford_ner_dir, 'classifiers')

    ner_outputfile = input_file + os.path.extsep + 'ne'
    command = command % (ner_models_dir, input_file, ner_outputfile)
    print command
    result = os.system(command)
    if result <> 0:
        print 'Bad Ner result: %s' % result

    entities = crawler_package.Entity_Extractor.Entity_Extractor(ner_outputfile)

    entities.results(names_file)

if __name__ == '__main__':
    main()
