#!/usr/bin/env python

import sys, os.path
import crawler_package.call_entity_extractor

if __name__ == '__main__':
    ### Call the Stanford named entity extractor on
    ### some files created by the web crawler.
    ###  Stanford named_entity extractor seems to work a little
    ### more reliably on an html file, perhaps because the
    ### preserved html structure helps do some parsing.
    ### But also extract a small set of names from the
    ### '.description' files culled from 'description'
    ### meta-tags.
    #good_extensions = ['html', 'htm', 'description']
    #good_extensions = ['rgn']
    good_extensions = ['txt']
    home = os.environ['HOME']
    working_dir = os.path.join(home, 'ext', 'src',\
                            'stanford-parser-2011-04-20','blood')
    # working_dir = os.path.join(root_dir, 'splcenter.org','get-informed',\
    #                           'intelligence-files', 'groups')
    # working_dir = os.path.join(root_dir, 'crawled_files','louisbeam.com')
    if len(sys.argv) > 1:
        working_dir = sys.argv[1]
    else:
        print 'Using default working dir: %s' % working_dir
    os.chdir(working_dir)
    file_list = os.listdir(working_dir)
    for fn in file_list:
        (base, ext) = os.path.splitext(fn)
        ext = ext[1:]  # strip extension separator
        if ext in good_extensions:
            new_name = base + '-' + ext + os.path.extsep + 'names'
            call_entity_extractor.main(os.path.join(working_dir,fn), new_name)
            

