"""
Given a directory of files containing pages to download, download them.
The files may be in xls format.

Note: we are not crawling, just downloading single pages to collect data.
Hence call_crawler is called with fetch_only=True.
"""

from crawler_package.basic_crawler import Crawler, call_crawler
from crawler_package import convert_xl
from xgoogle_utils import read_in_stringlist    
import os.path

def crawl_search_dir (search_dir,write_dir=None):
    website_files = os.listdir(search_dir)
    crawled_sites_file = os.path.join(search_dir,'crawled_sites.txt')
    if os.path.isfile(crawled_sites_file):
        ofh = open(crawled_sites_file,'a')
        crawled_sites = read_in_stringlist(crawled_sites_file)
    else:
        ofh = open(crawled_sites_file,'w')
        crawled_sites = []
    
    for fn in website_files:
        fullpath =  os.path.join(search_dir,fn)
        (base,ext) = os.path.splitext(fullpath)
        if ext in convert_xl.xls_exts:
            fullpath = convert_xl.convert_to_text_file(base,ext,format='simple')
        print 'full_path', fullpath
        if os.path.isfile(fullpath):
            fh = open(fullpath,'r')
            for line in fh:
                url = line.strip()
                if url not in crawled_sites:
                    crawler = Crawler(url, None, write_dir=write_dir)
                    call_crawler(crawler, url, write_dir=write_dir,\
                                 store_content=True,write_content=True,\
                                 fetch_only=True)
                    crawled_sites.append(url)
                    print >> ofh, url
            fh.close()
    ofh.close()
    
    
if __name__ == '__main__':

    home = os.getenv('HOME')
    xgoogle_dir = os.path.join(home, 'ext','src','xgoogle','xgoogle')
    search_dir = os.path.join(xgoogle_dir,'xcel_random_results')
    write_dir = os.path.join(xgoogle_dir,'random_data')
    crawl_search_dir (search_dir,write_dir)

